############################################################
#
# type definition pro_declaration_component_globuscfg
#
# RESPONSIBLE: Novak Judit <judit.novak@cern.ch>
#
# AUTHOR: Novak Judit <judit.novak@cern.ch>
#
# VERSION: 0.0.12
#
############################################################

declaration template pro_declaration_component_globuscfg;

include pro_declaration_structures;

define type reg_type = {
	"recordname" : string
	"regname" ? string
	"reghn" ? string
	"regport" ? long
	"regperiod" ? long
	"ttl" ? long
};

define type globus_mds_gris_type = {
	"suffix" ? string
	"provider" ? string{}
	"registration" ? reg_type[]
};

define type globus_mds_giis_allowedregs_type = {
	"recordname" : string
	"name" ? string		
	"allowreg" ? string[]
};

define type globus_mds_giis_reg_type = {
	"regname" : string
	"reghn" : string
	"regport" ? long
	"regperiod" ? long
	"ttl" ? long
	"name" ? string
};

define type globus_mds_giis_type = {
	"allowedregs" ? globus_mds_giis_allowedregs_type[]
	"registration" ? globus_mds_giis_reg_type{}
};

define type globus_mds_type = {
	"globus_flavor_name" ? string
	"user" ? string
	"x509_user_cert" ? string
	"x509_user_key" ? string
	"gris" ? globus_mds_gris_type
	"giis" ? globus_mds_giis_type
};

define type globus_gridftp_type = {
	"globus_flavor_name" ? string
	"X509_USER_CERT" ? string
	"X509_USER_KEY" ? string
	"ftpd" ? string
	"port" ? string
	"umask" ? string
	"log" ? string
	"user" ? string
	"options" ? string
};

define type globus_gatekeeper_jobmanager_type = {
	"recordname" : string
	"type" ? string
	"job_manager" ? string 
	"extra_config" ? string	
};

define type globus_gatekeeper_type = {
	"globus_flavor_name" ? string
	"job_manager_path" ? string[]
	"globus_gatekeeper" ? string
	"extra_options" ? string
	"user" ? string
	"port" ? long
	"logfile" ? string
	"jobmanagers" ? globus_gatekeeper_jobmanager_type[]
};

define type globus_global_type = {
	"services" ? string[]
	"paths" ? string[]
	"globus_flavor_name" : string
	"GLOBUS_LOCATION" : string	
	"GLOBUS_CONFIG" : string	
	"GLOBUS_TCP_PORT_RANGE" ? string	
	"GLOBUS_UDP_PORT_RANGE" ? string	
	"x509_user_cert" ? string
	"x509_user_key" ? string
	"gridmap" ? string
	"gridmapdir" ? string
	"mds" ? globus_mds_type
	"gridftp" ? globus_gridftp_type
	"gatekeeper" ? globus_gatekeeper_type
};

define type component_globuscfg_type = {
	include structure_component
	include globus_global_type
};


type "/software/components/globuscfg" = component_globuscfg_type;


